/*
                    prt - output a file to lpt

         Richard C. Allen, 1988 March 22 - original lpt1 version
         Richard C. Allen, 1993 March 7 - added multiple ports

    CAUTION: To achieve the blazing speed, this program does no
             error checking!  If you want error checking, use the
             dos copy function which is about 50 times slower.

    This routine will drive a LaserJet 4 at about 200 kbytes/second
    from a 486/33.  PostScript output to the Tektronix Phaser IIsd
    runs about 75 kbytes/second.


    This program has been compiled with Microsoft 5.1 / Masm 5.1 but
    should be upward compatible.
*/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

extern void prta(char c,short port);

static void help_out(void)
{
    fprintf(stderr,"\n");
    fprintf(stderr,"\nusage> prt filename [lpt#]\n\n");
    fprintf(stderr,"    where  filename is full file name\n");
    fprintf(stderr,"      and  lpt# is 1, 2, or 3 (default is 1)\n");
    fprintf(stderr,"\n  (CAUTION: no error checking performed!)\n");
    exit(0x7fff);
}

void main(
int ntokens,
char *tokens[])
{
    FILE *file;
    short c;
    short lp;           /* lp #, 1, 2, or 3 */
    short port;         /* printer port */
    short *lpt;         /* -> lpt port */

    fprintf(stderr,"\nprt - fast lpt output - R. C. Allen - 1993 March 7\n");
    lpt = (short *) 0x00400008;     /* -> lpt1 address */
    lp = 1;                         /* default to lpt1 */
    port = lpt[0];                  /* default port */

    if (ntokens < 2)
    {
        help_out();
    }

    if (ntokens > 2)
    {
        lp = atoi(tokens[2]);
        switch (lp)
        {
            case 1: port = lpt[0]; break;
            case 2: port = lpt[1]; break;
            case 3: port = lpt[2]; break;
            default:
                fprintf(stderr,"\n%d is not a valid printer #\n",lp);
                help_out();
        }
    }
    if (!port)
    {
        fprintf(stderr,"\nno lpt%d found ...\n",lp);
        help_out();
    }
    
    fprintf(stderr,"\noutput %s to lpt%d at 0x%04x ...\n",
            tokens[1],lp,port);

    file = fopen(tokens[1],"rb");
    if (file == NULL)
    {
        fprintf(stderr,"\ncannot open %s\n",tokens[1]);
        exit(0x7fff);
    }

    while ((c = fgetc(file)) != EOF)    /* do the output ... */
    {
        prta(c,port);
    }
}

